package Listes;

public class ListeTriee {
	private Doublet tete, queue;

	public ListeTriee() {
		tete = null; queue = null;
	}
	
	public void inserer(int e) {
	// insre e dans la liste trie 
		Doublet k, a, p;  // doublet cr, courant, prcdent
		k = new Doublet(e);
		a = tete; p = null;
		while ((a != null) && (a.el < e)) {
			p = a; a = a.suiv;
		}
		// a = null || a.el >= e : on place e avant a => aprs p
		if (p == null) {
			k.suiv = tete ; tete = k;
		} else {
			k.suiv = a ; p.suiv = k;
		}
	}
	public void inserer2(int e) {
		tete = insererrec(e, tete);
	}

	private Doublet insererrec(int e, Doublet t) {
		Doublet a; // doublet cr
		if ((t != null) && (e > t.el)){
			t.suiv = insererrec(e, t.suiv);
		} else {
			a = new Doublet(e);
			a.suiv = t;
			t = a;
		}
		return(t);
	}
	
	public void afficher() {
		Doublet a = tete;
		while (a != null) {
			System.out.print(a.el+" ");
			a = a.suiv;
		}
		System.out.println();
	}

	public void ajoutQueue(int e) {
		Doublet k = new Doublet(e);
		if (tete == null) {
			tete = k; 
			queue = tete;
		} else {
			queue.suiv = k; 
			queue = k;
		}
	}
	
	private Doublet eltc;   // lment courant pour parcours de la liste
	
	public Doublet eltc(){
		return eltc;
	}	
	public void demarrer(){
		eltc = tete;
	}
	public void avancer() {
		eltc = eltc.suiv;
	}
	
public void intersection(ListeTriee l1, ListeTriee l2) {
	Doublet a1, a2; // elments courants de l1, l2
	tete = new Doublet(0); // lment fictif en tte
	queue = tete;
	a1 = l1.tete ; a2 = l2.tete;
	while ((a1 != null) & (a2 != null)) {
		if (a1.el < a2.el) {
			a1 = a1.suiv ;
		} else {
		if (a1.el > a2.el) {
			a2 = a2.suiv ;
		} else {
		// a1.el == a2.el
			queue.suiv = new Doublet(a1.el); queue = queue.suiv;
			a1 = a1.suiv ; a2 = a2.suiv ;
		}
		}
	}
	// a1 == null | a2 == null
	queue.suiv = null;
	tete = tete.suiv; // lment fictif supprim et rcupr par le garbage collector !
}


}
